/**********************************************
(sondelog_wind.c)
This program read GPS sonde log data.


            02.11.27 made by Miunehisa YAMAMOTO
**********************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define TIME 10800  //3h*3600s

int main(int argc, char *argv[])
{

    FILE	*fpi, *fpo;
    int		i, datanum;
    char	buf[256], bufmin[4], bufs[3], bufP[9], bufgpH[8];
    char	bufH[6], bufS[6], bufD[7];
    int		min, s;
    int		t[TIME], gpH[TIME], H[TIME];
    float	P[TIME], S[TIME], D[TIME], u[TIME], v[TIME];
    float	pi=3.1415926535;

    if(argc!=2){
    	printf("Usage: sondelog_wind filename\n");
	exit(0);
    }

/*** Open File***/
    if((fpi=fopen(argv[1],"r"))==NULL){
    	printf("***inputfile cannot open***\n");
	exit(0);
    }
    fpo=fopen("test_wind.csv","w");
    fprintf(fpo,"t(s),P(hPa),H(gpm),S(m/s),D(deg),U(m/s),V(m/s)\n");

/*** Read index***/
    for(i=0;i<5;i++) fgets(buf, 256, fpi);
    fgets(buf, 256, fpi); printf("%s",buf);  //StartTime
    for(i=0;i<2;i++) fgets(buf, 256, fpi);
    fgets(buf, 256, fpi); printf("%s",buf);  //Location
    for(i=0;i<2;i++) fgets(buf, 256, fpi);
    fgets(buf, 256, fpi); printf("%s",buf);  //RSnumber
    for(i=0;i<27;i++) fgets(buf, 256, fpi);

/*** Read data***/
    i=0;

    while(!feof(fpi)){
    	if(i>=TIME) break;

    	fscanf(fpi,"%4s%3s%9s%8s%6s%6s%7s",
		bufmin, bufs, bufP, bufgpH ,bufH, bufS, bufD);
	min = atoi(bufmin);
	  s = atoi(bufs);
	t[i] =s+min*60;
	P[i] = atof(bufP);
	gpH[i] = atoi(bufgpH);
	H[i] = atoi(bufH);
	S[i] = atof(bufS);
	D[i] = atof(bufD);

	if(S[i]==0. && D[i]==0.){S[i]=-9999.; D[i]=-9999.;}
	if(gpH[i]==0)gpH[i]=-9999;

	i++;
    }
    datanum=i;

/***calclation***/

    for(i=0;i<datanum;i++){
    	if(S[i]<0. || D[i]<0.){
		u[i]=-9999.;  v[i]=-9999.;
	}
	else{
    		u[i]=-S[i]*sin(D[i]*pi/180.);
    		v[i]=-S[i]*cos(D[i]*pi/180.);
	}
	
	fprintf(fpo,"%d,%5.1f,%d,%3.1f,%3.0f,%3.1f,%3.1f\n",
		t[i],P[i],gpH[i],S[i],D[i],u[i],v[i]);
    }

    fclose(fpi);
    fclose(fpo);
    return 0;
}
